# -*- coding: utf-8 -*-
"""
Created on Fri Jun  5 15:58:47 2020

@author: Ocean Insight Inc.
"""

from oceandirect.od_logger import od_logger
from oceandirect.OceanDirectAPI import OceanDirectAPI, OceanDirectError


# create stream logger
logger = od_logger("logtest")


def get_spec_raw(device_ids):
    od = OceanDirectAPI()
    sn = ""
    device_id = -1

    #Open 1 device at a time and then read spectra
    for id in device_ids:
        try:
            print("opening device id =  %d" % id)
            device = od.open_device(id)
            sn = device.get_serial_number()

            try:
                #50ms
                device.set_integration_time(50000);
                #device.take_dark()
                #device.take_reference() 

                print("[START] Reading spectra for dev s/n = %s" % sn, flush=True)
                for i in range(10):
                    spectra = device.get_formatted_spectrum()
                    print("spectra[100]: %d, %d, %d, %d" % (spectra[100], spectra[200], spectra[300], spectra[400]))

                print("[END] Closing device [%s]!" % sn)
                od.close_device(id)
            except OceanDirectError as e:
                logger.error(e.get_error_details())

            break;
        except OceanDirectError as e:
            logger.error(e.get_error_details())


if __name__ == '__main__':

    od = OceanDirectAPI()
    device_ids = od.get_device_ids()

    device_count = len(device_ids)
    print("Total Device: %d " % device_count)

    if device_count == 0:
        print("No device found.")
    else:
        print("First Device: %d " % device_ids[0])
        get_spec_raw(device_ids)

    print("**** exiting program ****")
    

